//package agents;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.Random;

import negotiator.Agent;
import negotiator.Bid;
import negotiator.actions.Accept;
import negotiator.actions.Action;
import negotiator.actions.Offer;
import negotiator.issue.Issue;
import negotiator.issue.IssueDiscrete;
import negotiator.issue.IssueInteger;
import negotiator.issue.IssueReal;
import negotiator.issue.Value;
import negotiator.issue.ValueDiscrete;
import negotiator.issue.ValueInteger;
import negotiator.issue.ValueReal;

/**
 * @author W.Pasman Some improvements over the standard SimpleAgent.
 */
public class AgentMR extends Agent {
	private Action actionOfPartner = null;
	private ArrayList<Bid> bidRunk = new ArrayList<Bid>();
	// ǾBid
	// ʲUtilityФʤ
	private static int WAIT_COUNT = 3;
	private static double WAIT_TIME = 0.20;
	private static double MINIMUM_ACCEPT_UTILITY = 0.90;
	private static double MINIMUM_ACCEPT_P = 0.60;
	private double MINIMUM_BID_UTILITY = 0.80;
	private double previousOffer = 0.3;
	private boolean fflag = true;
	private Action previousAction = null;
	private int waitAction = 0;
	private int curRunk = 0;

	/**
	 * init is called when a next session starts with the same opponent.
	 */
	public void init() {
		try {
			HashMap<Bid, Double> bidTable = getBid(0);
			sortBid(bidTable);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		if (utilitySpace.getReservationValue() != null)
			MINIMUM_BID_UTILITY = utilitySpace.getReservationValue();
	}

	public static String getVersion() {
		return "1.2";
	}

	public void ReceiveMessage(Action opponentAction) {
		actionOfPartner = opponentAction;
	}

	public Action chooseAction() {
		Action action = null;

		try {
			if (actionOfPartner == null)
				// Utility礭Τ
				action = new Offer(getAgentID(), utilitySpace
						.getMaxUtilityBid());
			if (actionOfPartner instanceof Offer) {
				Bid partnerBid = ((Offer) actionOfPartner).getBid();
				double offeredutil = getUtility(partnerBid); // ¦󼨾utility
				//System.out.println("Off; " + offeredutil + " PreOff; "
				//		+ previousOffer);
				// get current time
				double time = timeline.getTime();
				if (time > 0.75) {
					MinimumBidUtility(time);
				}
				double P = Paccept(offeredutil, time);
				//System.out.println("P; " + P);
				if ((P > MINIMUM_ACCEPT_P)
						|| (offeredutil > MINIMUM_ACCEPT_UTILITY)) { // PͤutilityͤĶAccept
					action = new Accept(getAgentID());
				} else {
					if (fflag) { // WAIT_TIMEޤǤϺǹͤBid³
						action = new Offer(getAgentID(), utilitySpace
								.getMaxUtilityBid());
						if(time > WAIT_TIME) {
							fflag = !fflag;
							previousAction = action;
						}
					} else if (offeredutil > previousOffer) { // ¦offer줿
						// ¦׵˹碌
						HashMap<Bid, Double> bidTable = getBid(1);
						if (bidTable.size() >= 2) {
							sortBid(bidTable);
							for (Bid b : bidRunk) {
								 //System.out.println("*Bid:" + b + "\n*Util:" + bidTable.get(b));
								}
							curRunk = 0;
						} else {
							//System.out.println("NotFoundBid.");
						}
						action = new Offer(getAgentID(), bidRunk.get(curRunk));
						previousAction = action;
						previousOffer = offeredutil;
						waitAction = 0;
						if (curRunk >= bidRunk.size() - 1) {
							curRunk = 0;
						} else {
							curRunk++;
						}
					} else if (waitAction > WAIT_COUNT) { // ¦offerѲ̵
						// utilityι⤤󼨤Ƥߤ
						action = new Offer(getAgentID(), bidRunk.get(curRunk));
						previousAction = action;
						previousOffer = offeredutil;
						waitAction = 0;
						if (curRunk >= bidRunk.size() - 1) {
							curRunk = 0;
						} else {
							curRunk++;
						}
					} else {
						action = previousAction;
						waitAction++; // WAIT_COUNTޤǤԤäƤߤ
					}
				}
			}
			//sleep(0.005); // just for fun
		} catch (Exception e) {
			//System.out.println("Exception in ChooseAction:" + e.getMessage());
			action = new Accept(getAgentID()); // best guess if things go wrong.
		}
		return action;
	}

	// ǾBid
	private void MinimumBidUtility(double t) {
		MINIMUM_BID_UTILITY = 0.55 + (1 - t);
	}

	/**
	 * Wrapper for getRandomBid, for convenience.
	 * 
	 * @return new Action(Bid(..)), with bid utility > MINIMUM_BID_UTIL. If a
	 *         problem occurs, it returns an Accept() action.
	 */
	private Action chooseRandomBidAction() {
		Bid nextBid = null;
		try {
			nextBid = getRandomBid();
		} catch (Exception e) {
			//System.out.println("Problem with received bid:" + e.getMessage()
				//	+ ". cancelling bidding");
		}
		if (nextBid == null)
			return (new Accept(getAgentID()));
		return (new Offer(getAgentID(), nextBid));
	}
	
	/**
	 * BidUtility߽˥
	 * @param bidTable
	 */
	private void sortBid(final HashMap<Bid,Double> bidTable) {
		//if (!bidRunk.isEmpty())
		//	bidRunk.clear();
		for (Bid b : bidTable.keySet()) {
			bidRunk.add(b);
		}

		Collections.sort(bidRunk, new Comparator<Bid>() {
			@Override
			public int compare(Bid o1, Bid o2) {
				return (int) Math.ceil(-(bidTable.get(o1) - bidTable
						.get(o2)));
			}
		});
	}
	
	/**
	 * äBid᤯Utilityι⤤Bid
	 * @param maxBid
	 * @return
	 * @throws Exception
	 */
	private HashMap<Bid, Double> getBid(int flag) throws Exception {
		HashMap<Bid, Double> curIssueUtility = new HashMap<Bid, Double>();
		ArrayList<Issue> issues = utilitySpace.getDomain().getIssues();
		Bid curBid;
		
		for (Issue lIssue : issues) {
			switch (lIssue.getType()) {
			case DISCRETE:
				IssueDiscrete lIssueDiscrete = (IssueDiscrete) lIssue;
				for (ValueDiscrete i : lIssueDiscrete.getValues()) {
					if (flag == 0) {
						curBid = utilitySpace.getMaxUtilityBid();
					} else {
						curBid = ((Offer) actionOfPartner).getBid();
					}
					curBid.setValue(lIssue.getNumber(), i);
					double utility = getUtility(curBid);
					if (utility > MINIMUM_BID_UTILITY) {
						curIssueUtility.put(curBid, utility);
					}
				}
				break;
			default:
				throw new Exception("issue type " + lIssue.getType()
						+ " not supported by MyAgent");
			}
		}
		for(Bid b : curIssueUtility.keySet()) {
			//System.out.println("Bid:"+b+"\nUtil:"+curIssueUtility.get(b));
		}
		return curIssueUtility;
	}

	/**
	 * @return a random bid with high enough utility value.
	 * @throws Exception
	 *             if we can't compute the utility (eg no evaluators have been
	 *             set) or when other evaluators than a DiscreteEvaluator are
	 *             present in the util space.
	 */
	private Bid getRandomBid() throws Exception {
		HashMap<Integer, Value> values = new HashMap<Integer, Value>(); // pairs
		// <issuenumber,chosen
		// value
		// string>
		ArrayList<Issue> issues = utilitySpace.getDomain().getIssues();
		Random randomnr = new Random();

		// create a random bid with utility>MINIMUM_BID_UTIL.
		// note that this may never succeed if you set MINIMUM too high!!!
		// in that case we will search for a bid till the time is up (2 minutes)
		// but this is just a simple agent.
		Bid bid = null;
		do {
			for (Issue lIssue : issues) {
				switch (lIssue.getType()) {
				case DISCRETE:
					IssueDiscrete lIssueDiscrete = (IssueDiscrete) lIssue;
					// °
					int optionIndex = randomnr.nextInt(lIssueDiscrete
							.getNumberOfValues());
					values.put(lIssue.getNumber(), lIssueDiscrete
							.getValue(optionIndex));
					break;
				case REAL:
					IssueReal lIssueReal = (IssueReal) lIssue;
					int optionInd = randomnr.nextInt(lIssueReal
							.getNumberOfDiscretizationSteps() - 1);
					values.put(lIssueReal.getNumber(), new ValueReal(lIssueReal
							.getLowerBound()
							+ (lIssueReal.getUpperBound() - lIssueReal
									.getLowerBound())
							* (double) (optionInd)
							/ (double) (lIssueReal
									.getNumberOfDiscretizationSteps())));
					break;
				case INTEGER:
					IssueInteger lIssueInteger = (IssueInteger) lIssue;
					int optionIndex2 = lIssueInteger.getLowerBound()
							+ randomnr.nextInt(lIssueInteger.getUpperBound()
									- lIssueInteger.getLowerBound());
					values.put(lIssueInteger.getNumber(), new ValueInteger(
							optionIndex2));
					break;
				default:
					throw new Exception("issue type " + lIssue.getType()
							+ " not supported by SimpleAgent2");
				}
			}
			bid = new Bid(utilitySpace.getDomain(), values);
		} while (getUtility(bid) < MINIMUM_BID_UTILITY);

		return bid;
	}

	/**
	 * This function determines the accept probability for an offer. At t=0 it
	 * will prefer high-utility offers. As t gets closer to 1, it will accept
	 * lower utility offers with increasing probability. it will never accept
	 * offers with utility 0.
	 * 
	 * @param u
	 *            is the utility
	 * @param t
	 *            is the time as fraction of the total available time (t=0 at
	 *            start, and t=1 at end time)
	 * @return the probability of an accept at time t
	 * @throws Exception
	 *             if you use wrong values for u or t.
	 * 
	 */
	double Paccept(double u, double t1) throws Exception {
		double t = t1 * t1 * t1; // steeper increase when deadline approaches.
		if (u < 0 || u > 1.05)
			throw new Exception("utility " + u + " outside [0,1]");
		// normalization may be slightly off, therefore we have a broad boundary
		// up to 1.05
		if (t < 0 || t > 1)
			throw new Exception("time " + t + " outside [0,1]");
		if (u > 1.)
			u = 1;
		if (t == 0.5)
			return u;
		// PAcceptValue
		return (u - 2. * u * t + 2. * (-1. + t + Math.sqrt(sq(-1. + t) + u
				* (-1. + 2 * t))))
				/ (-1. + 2 * t);
	}

	double sq(double x) {
		return x * x;
	}
}
