//package agents;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Random;

import negotiator.Agent;
import negotiator.Bid;
import negotiator.actions.Accept;
import negotiator.actions.Action;
import negotiator.actions.Offer;
import negotiator.issue.Issue;
import negotiator.issue.IssueDiscrete;
import negotiator.issue.IssueInteger;
import negotiator.issue.IssueReal;
import negotiator.issue.Value;
import negotiator.issue.ValueDiscrete;
import negotiator.issue.ValueInteger;
import negotiator.issue.ValueReal;
import negotiator.utility.EvaluatorDiscrete;


public class AgentMZ extends Agent
{
	private Action actionOfPartner=null;
	private static double MINIMUM_BID_UTILITY;
	private static double MAX_U;
	private static double MIN_U=0;
	
	private static Bid preBid=null;
	HashMap<Integer, Value> valuesp = new HashMap<Integer, Value>();

	/**
	 * init is called when a next session starts with the same opponent.
	 */
	public void init()
	{
		try {
			MAX_U=getUtility(utilitySpace.getMaxUtilityBid());
		} catch (Exception e) {
			e.printStackTrace();
		}
		double df=utilitySpace.getDiscountFactor();//
		if(df==0)df=0.9*MAX_U;
		MINIMUM_BID_UTILITY=(MAX_U+df)/2;
		//System.out.println(MINIMUM_BID_UTILITY);
		
		if(utilitySpace.getReservationValue() != null)
			MINIMUM_BID_UTILITY = utilitySpace.getReservationValue();
		
		ArrayList<Issue> issues=utilitySpace.getDomain().getIssues();
		for(Issue lIssue:issues){
			try {
				MIN_U+=utilitySpace.getWeight(lIssue.getNumber())*((EvaluatorDiscrete) utilitySpace.getEvaluator(lIssue.getNumber())).getEvaluation((ValueDiscrete) ((EvaluatorDiscrete) utilitySpace.getEvaluator(lIssue.getNumber())).getMinValue());
				//System.out.println("kokookokkokko"+MIN_U);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}

	//݂̃o[WԂ
	public static String getVersion() { return "0.2"; }

	//̍s擾
	public void ReceiveMessage(Action opponentAction) 
	{
		actionOfPartner = opponentAction;
	}


	//g̍s̑I
	public Action chooseAction()
	{
		Action action = null;
		ArrayList<Issue> issuesz=utilitySpace.getDomain().getIssues();
		HashMap<Integer, Value> valuesp = new HashMap<Integer, Value>();
		
		try 
		{
			//炪ŏɒĂꍇ
			if(actionOfPartner==null) action = chooseBidAction();
			//̃It@[󂯎ꍇ
			if(actionOfPartner instanceof Offer)
			{
				//̃It@[̒g擾
				Bid partnerBid = ((Offer)actionOfPartner).getBid();
				double cos = utilitySpace.getCost(partnerBid);//
				//̃It@[̎ǧpԂł̌p̎擾
				double offeredutil = getUtility(partnerBid);
				//ݎ̎擾
				double time = timeline.getTime();
				
				if(preBid!=null){
					for(Issue lIssue:issuesz){
						switch(lIssue.getType()) {
						case DISCRETE:
							//IssueDiscrete lIssueDiscrete = (IssueDiscrete)lIssue;
							if(preBid.getValue(lIssue.getNumber())==partnerBid.getValue(lIssue.getNumber()))
								valuesp.put(lIssue.getNumber(), preBid.getValue(lIssue.getNumber()));
							break;
						case REAL:
							IssueReal lIssueReal = (IssueReal)lIssue;
							if(preBid.getValue(lIssueReal.getNumber())==partnerBid.getValue(lIssueReal.getNumber()))
								valuesp.put(lIssueReal.getNumber(), preBid.getValue(lIssueReal.getNumber()));
							break;
						case INTEGER:
							IssueInteger lIssueInteger = (IssueInteger)lIssue;
							if(preBid.getValue(lIssueInteger.getNumber())==partnerBid.getValue(lIssueInteger.getNumber()))
								valuesp.put(lIssueInteger.getNumber(), preBid.getValue(lIssueInteger.getNumber()));
							break;
						default: throw new Exception("issue type "+lIssue.getType()+" not supported by SAgent");
						}
					}
				}
				
				//System.out.println(""+);
				/*
				 *玞Ԍo߂ɂ̓x肷B
				 */
				if(cos<=1200){
					if(time<=0.6){
						if(offeredutil>=MINIMUM_BID_UTILITY)
							action = new Accept(getAgentID());
						else action =chooseBidAction();
					}
					else{
						double acu = ((-25)*Math.pow((time-0.6), 2))/16+MINIMUM_BID_UTILITY;
						if(offeredutil>=acu)
							action = new Accept(getAgentID());
						else action =chooseBidAction();
					}
				}
				else
					action = chooseBidAction();
				/*c
				double P=Paccept(offeredutil,time);
				if (P>Math.random()) 
					action = new Accept(getAgentID());
				else action = chooseBidAction();               
				*/
				preBid=partnerBid;
			}
			//sleep(0.005); //kiHj
		} catch (Exception e) { 
			//System.out.println("Exception in ChooseAction:"+e.getMessage());
			action=new Accept(getAgentID()); // best guess if things go wrong. 
		}
		
		return action;
	}

	/**
	 * Wrapper for getRandomBid, for convenience.
	 * @return new Action(Bid(..)), with bid utility > MINIMUM_BID_UTIL.
	 * If a problem occurs, it returns an Accept() action.
	 */
	//炪It@[Bid̑I
	private Action chooseBidAction() 
	{
		Bid nextBid=null ;
		try { nextBid = getMyBid(); }
		catch (Exception e) { 
			
			//System.out.println("Problem with received bid:"+e.getMessage()+". cancelling bidding");
		
		}
		if (nextBid == null) return (new Accept(getAgentID()));                
		return (new Offer(getAgentID(), nextBid));
	}

	/**
	 * @return a random bid with high enough utility value.
	 * @throws Exception if we can't compute the utility (eg no evaluators have been set)
	 * or when other evaluators than a DiscreteEvaluator are present in the util space.
	 */
	private Bid getMyBid() throws Exception
	{
		HashMap<Integer, Value> values = new HashMap<Integer, Value>(); // pairs <issuenumber,chosen value string>
		ArrayList<Issue> issues=utilitySpace.getDomain().getIssues();
		Random randomnr= new Random();
		
		double minb = MINIMUM_BID_UTILITY;
		double low = MINIMUM_BID_UTILITY+0.0001;
		double lowp =MINIMUM_BID_UTILITY*0.95;
		int i=0;

		// create a random bid with utility>MINIMUM_BID_UTIL.
		// note that this may never succeed if you set MINIMUM too high!!!
		// in that case we will search for a bid till the time is up (2 minutes)
		// but this is just a simple agent.
		Bid bid=null;
		double cos=0;
		do 
		{
			for(Issue lIssue:issues) 
			{
				switch(lIssue.getType()) {
				case DISCRETE:
					IssueDiscrete lIssueDiscrete = (IssueDiscrete)lIssue;
					if((i<10)&&(valuesp.get(lIssue.getNumber())!=null)){
						values.put(lIssue.getNumber(), valuesp.get(lIssue.getNumber()));
						minb=lowp;
					}
					else{
						int optionIndex=randomnr.nextInt(lIssueDiscrete.getNumberOfValues());
						values.put(lIssue.getNumber(), lIssueDiscrete.getValue(optionIndex));
						minb=low;
					}
					break;
				case REAL:
					IssueReal lIssueReal = (IssueReal)lIssue;
					if((i<10)&&(valuesp.get(lIssueReal.getNumber())!=null)){
						values.put(lIssueReal.getNumber(), valuesp.get(lIssueReal.getNumber()));
						minb=lowp;
					}
					else{
						int optionInd = randomnr.nextInt(lIssueReal.getNumberOfDiscretizationSteps()-1);
						values.put(lIssueReal.getNumber(), new ValueReal(lIssueReal.getLowerBound() + (lIssueReal.getUpperBound()-lIssueReal.getLowerBound())*(double)(optionInd)/(double)(lIssueReal.getNumberOfDiscretizationSteps())));
						minb=low;
					}
					break;
				case INTEGER:
					IssueInteger lIssueInteger = (IssueInteger)lIssue;
					if((i<10)&&(valuesp.get(lIssueInteger.getNumber())!=null)){
						values.put(lIssueInteger.getNumber(), valuesp.get(lIssueInteger.getNumber()));
						minb=lowp;
					}
					else{
						int optionIndex2 = lIssueInteger.getLowerBound() + randomnr.nextInt(lIssueInteger.getUpperBound()-lIssueInteger.getLowerBound());
						values.put(lIssueInteger.getNumber(), new ValueInteger(optionIndex2));
						minb=low;
					}
					break;
				default: throw new Exception("issue type "+lIssue.getType()+" not supported by SimpleAgent2");
				}
			}
			bid=new Bid(utilitySpace.getDomain(),values);
			cos = utilitySpace.getCost(bid);
			
			low-=0.0001;
			i++;
		} while ((getUtility(bid) < minb)||(cos>1200));

		return bid;
	}

	/**
	 * This function determines the accept probability for an offer.
	 * At t=0 it will prefer high-utility offers.
	 * As t gets closer to 1, it will accept lower utility offers with increasing probability.
	 * it will never accept offers with utility 0.
	 * @param u is the utility 
	 * @param t is the time as fraction of the total available time 
	 * (t=0 at start, and t=1 at end time)
	 * @return the probability of an accept at time t
	 * @throws Exception if you use wrong values for u or t.
	 * 
	 */
	/*
	double Paccept(double u, double t1) throws Exception
	{
		double t=t1*t1*t1; // steeper increase when deadline approaches.
		if (u<0 || u>1.05) throw new Exception("utility "+u+" outside [0,1]");
		// normalization may be slightly off, therefore we have a broad boundary up to 1.05
		if (t<0 || t>1) throw new Exception("time "+t+" outside [0,1]");
		if (u>1.) u=1;
		if (t==0.5) return u;
		return (u - 2.*u*t + 2.*(-1. + t + Math.sqrt(sq(-1. + t) + u*(-1. + 2*t))))/(-1. + 2*t);
	}
	*/

	double sq(double x) { return x*x; }
}
