package negotiation.group4;

import negotiator.Bid;

/**
 * @author Lennaert van den Brink <l.o.vandenbrink@student.tudelft.nl>
 * @author Hans Janmaat <c.j.janmaat@student.tudelft.nl>
 * @author Cees-Willem Hofstede <c.w.p.l.j.hofstede@student.tudelft.nl>
 * @author Berend Klein Haneveld <b.a.kleinhaneveld@student.tudelft.nl>
 */
public class ExtendedBid implements Comparable<ExtendedBid> {
	public Bid bid;
	public double utility;
	
	/**
	 * Constructor
	 * @param bid Bid
	 * @param utility Utility value of the bid
	 */
	public ExtendedBid(Bid bid, double utility) {
		this.bid = bid;
		this.utility = utility;
	}

	@Override
	public int compareTo(ExtendedBid arg0) {
		return Double.compare(arg0.utility, utility);
	}
	
	/**
	 * Compares another bid based on values
	 * @param otherBid ExtendedBid to compare
	 * @return boolean whether bid values are the same
	 */
	public boolean equals(ExtendedBid otherBid) {
		// Double/Triple checked: equals checks the values of the bids
		return otherBid.bid.equals(this.bid);
	}
}
