package travelingsalesman;

public class TravelingSalesman extends DecoupledAgent {

	/**
	 * Initializes the agent by setting the opponent model, the opponent model strategy,
	 * bidding strategy, and acceptance conditions.
	 */
	@Override
	public void agentSetup() {
		opponentModel = new IAMhagglerModel(true, 0.6);
		try {
			opponentModel.init(negotiationSession, null);
		} catch (Exception e) {
			e.printStackTrace();
		}
		omStrategy = new NullStrategy();
		try {
			omStrategy.init(negotiationSession, opponentModel, null);
		} catch (Exception e) {
			e.printStackTrace();
		}
		try {
			offeringStrategy = new TravelingSalesman_Offering(negotiationSession, opponentModel, omStrategy);
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		acceptConditions = new AC_TravelingSalesman(negotiationSession, offeringStrategy, 1, 0, 1.0, 0, 0.98, 0.99);
	}

	/**
	 * Returns the agent's name.
	 */
	@Override
	public String getName() {
		return "The Salesman";
	}
}